<?php

/**
 * nagios check skript for RWE-SmartHome,  
 *                    needs SmartHome-PHP, see:  https://github.com/Bubelbub/SmartHome-PHP
 *
 * @author     michaelano user from http://www.rwe-smarthome-forum.de
 * @version    0.03
 *     0.03  adapted for new "SmartHome-PHP-master" Version from 2014-07-14
 */


/* Usage:

- example nagios check new messages
   <path-to-script>/rd-rwe-smarthome.php -M -w 1 -c 1

- example nagios check humidity too high
   <path-to-script>/rd-rwe-smarthome.php -T -w 55 -c 60

*/

/*
Customization:
- customize config.ini File (or apply login info by the -H -u -p options)

in case of "(Return code of 255 is out of bounds) " errs in nagios, please check access right for the script ansd library
*/


require_once 'michaelano/SmartHome-Utils.php';
/*
mit alter Version der Librequire_once 'SmartHome-PHP-master/SmartHome.php';require_once 'SmartHome-PHP-master/SmartHome.php';
require_once 'SmartHome-PHP-master/Request/BaseRequest.php';
require_once 'SmartHome-PHP-master/Request/LoginRequest.php';
require_once 'SmartHome-PHP-master/Request/GetEntitiesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcInformationRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllLogicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetApplicationTokenRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcTypeRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllPhysicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetMessageListRequest.php';
*/


use Bubelbub\SmartHomePHP\SmartHome;
use Bubelbub\SmartHomePHP\Entity\LogicalDevice;

require_once 'SmartHome-PHP-master/SmartHome.php';
require_once 'SmartHome-PHP-master/Request/BaseRequest.php';
require_once 'SmartHome-PHP-master/Request/LoginRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllLogicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetMessageListRequest.php';
require_once 'SmartHome-PHP-master/Request/GetEntitiesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllPhysicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcInformationRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcTypeRequest.php';
require_once 'SmartHome-PHP-master/Request/GetUpdatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetApplicationTokenRequest.php';
require_once 'SmartHome-PHP-master/Entity/Entity.php';
require_once 'SmartHome-PHP-master/Entity/Location.php';
require_once 'SmartHome-PHP-master/Entity/LogicalDevice.php';
require_once 'SmartHome-PHP-master/Entity/Actuator.php';
require_once 'SmartHome-PHP-master/Entity/SwitchActuator.php';
require_once 'SmartHome-PHP-master/Entity/WindowDoorSensor.php';
require_once 'SmartHome-PHP-master/Entity/PushButtonSensor.php';
require_once 'SmartHome-PHP-master/Entity/ThermostatActuator.php';
require_once 'SmartHome-PHP-master/Entity/ValveActuator.php';
require_once 'SmartHome-PHP-master/Entity/RoomTemperatureActuator.php';
require_once 'SmartHome-PHP-master/Request/SetActuatorStatesRequest.php';
require_once 'SmartHome-PHP-master/Entity/TemperatureSensor.php';
require_once 'SmartHome-PHP-master/Entity/RoomTemperatureSensor.php';
require_once 'SmartHome-PHP-master/Entity/HumiditySensor.php';
require_once 'SmartHome-PHP-master/Entity/RoomHumiditySensor.php';
require_once 'SmartHome-PHP-master/Entity/MotionDetectionSensor.php';
require_once 'SmartHome-PHP-master/Entity/LuminanceSensor.php';
require_once 'SmartHome-PHP-master/Entity/AlarmActuator.php';
require_once 'SmartHome-PHP-master/Entity/SmokeDetectorSensor.php';
require_once 'SmartHome-PHP-master/Entity/GenericActuator.php';
require_once 'SmartHome-PHP-master/Entity/GenericSensor.php';










/**
 *  print help
 *
 * @param string $prgname
 * @param string $newLine
 */
function print_help_message ($prgname,$newLine)
{
  if  (php_sapi_name() == 'cli')
    {
    echo   "Usage: php $prgname [options]" . $newLine;
    }
  else
    {
    echo   "Options:" . $newLine;
    }
  echo   "       " . $newLine;
  echo   "  -h, --help             show this help" . $newLine;
  echo   "  -t, --temperature      show Temperature/Humidity (check temperature in case of nagios Plugin)" . $newLine;
  echo   "  -T, --humidity         show Temperature/Humidity (check humidity in case of nagios Plugin)" . $newLine;
  echo   "  -m, --messages         show Messages" . $newLine;
  echo   "  -M                     show (only) new Messages" . $newLine;
  echo   "  -o <rooms>             check only devices in room of list <rooms> (comma seperated)" . $newLine;
  echo   "  -x <rooms>             exclude devices in room of list <rooms> (comma seperated)" . $newLine;
  echo   "  -H <hostname>          hostname of shc" . $newLine;
  echo   "  -u <userid>            userid for login to shc" . $newLine;
  echo   "  -p <passwd>            passwd for login to shc" . $newLine;
  echo   "  -w <warnlevel>         set warnlevel (use this with -t,-T,-m or -M)" . $newLine;
  echo   "  -c <critlevel>         set critlevel (use this with -t,-T,-m or -M)" . $newLine;
  echo   "  -v, --verbose          verbose output" . $newLine;
  echo   "  -d, --debug            debug output" . $newLine;
}







// --- inits
$newLine             = php_sapi_name() == 'cli' ? "\n" : '<br />';
$configcachefile     = 'Configuration.cache';
$configIniFile       = __DIR__ . '/config.ini';

$argv0               = $argv[0];
$hostname            = "";
$userid              = "";
$passwd              = "";
$opttemperatures     = false;
$opthumidity         = false;
$optmsgs             = false;
$optmsgsnew          = false;
$optverbose          = false;
$optdebug            = false;














$opts = michaelano\SmartHomePHP\getoptreq('htTmMo:x:H:u:p:w:c:vd', array('help', 'temperature', 'humidity', 'messages',null ,null,null,null, null, null, null, null, 'verbose','debug'));
// --- command line arguments
foreach ($opts as $opt => $param) 
  {
  switch ($opt) 
    {
    case 't':
      $opttemperatures = true;
      $getlogicaldevstates = true;
      break;

    case 'T':
      $opthumidity = true;
      $getlogicaldevstates = true;
      break;

    case 'm':
      $optmsgs = true;
      break;

    case 'M':
      $optmsgsnew = true;
      break;

    case 'o':
      $optonly = explode(',',$param);
      break;

    case 'x':
      $optexclude = explode(',',$param);
      break;

    case 'H':
      $hostname = $param;
      break;

    case 'u':
      $userid = $param;
      break;

    case 'p':
      $passwd = $param;
      break;

    case 'w':
      $warnlevel    = floatval($param);
      $nagiosplugin = true;
      break;

    case 'c':
      $critlevel    = floatval($param);
      $nagiosplugin = true;
      break;

    case 'v':
      $optverbose = true;
      break;

    case 'd':
      $optdebug = true;
      break;

    case 'h':
      print_help_message($argv0,$newLine);
      exit(1);
    }
  }


if (count($opts) <= 0)
  michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage of plugin: no parameters given");

if ( ! isset($warnlevel) )
  michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage of plugin: warnlevel missing");

if ( ! isset($critlevel) )
  michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage of plugin: critlevel missing");






// --- Start 
if ($optverbose)
  {
  printf ("--- %s --- : %s" . $newLine , date ("r") , "Start" ) ;
  }







// --- construct SmartHome object
//$sh = new \Bubelbub\SmartHomePHP\SmartHome('Hostname or IP address', 'Username', 'Password');
//$sh = new \Bubelbub\SmartHomePHP\SmartHome($hostname,$userid,$passwd);
$sh = michaelano\SmartHomePHP\SmartHomeLogin($configIniFile,$hostname,$userid,$passwd);
if ($optdebug) 
  {
  print_r($sh->getShcInformation());
  }

if ($optverbose)
  {
  printf ("ConfigVrs: %s  (ShcVersion: %s, SessionId: %s)" . $newLine, $sh->getConfigVersion() ,$sh->getVersion() ,$sh->getSessionId()   ) ;
  printf ("--- %s --- : %s" . $newLine , date ("r") , "after Login" ) ;
  }











$CONFIGR = michaelano\SmartHomePHP\GetConfigR($sh,$configcachefile, $optdebug);
//$ROOMS   = $CONFIGR['Rooms'];
//$BDS     = $CONFIGR['BDs']  ;
//$LDS     = $CONFIGR['LDs']  ;
if ($optverbose) 
  {
  printf ("--- %s --- : %s" . $newLine , date ("r") , "after Config read" ) ;
  }









// --- 
if ( ($opttemperatures) || ($opthumidity) )
  {
  $RSTDATA = michaelano\SmartHomePHP\GetLogicalDeviceStates( $sh, $CONFIGR, true);
  $nagmsg  = "";
  $okmsg   =$opttemperatures         ? "Temperature: " : "Humidity: ";
  $retCode = NAGIOS_STATE_WARNING;
  foreach($RSTDATA as $ROOM => $VALUEARR) 
    {
    $value = floatval($opttemperatures ? $VALUEARR[0] : $VALUEARR[1]);
    if ( (isset($optonly)) && ( ! in_array($ROOM, $optonly))  )
      continue;
    if ( (isset($optexclude)) && (in_array($ROOM, $optexclude))  )
      continue;
    $tmp = sprintf("%s: %s;    "
                       , $ROOM 
                       , $opttemperatures         ? $VALUEARR[0]  : $VALUEARR[1] );
    $okmsg = $okmsg . $tmp;
    if (
       ( ($warnlevel < $critlevel) && ($value >= $warnlevel) )||
       ( ($warnlevel > $critlevel) && ($value <= $warnlevel) )  )
      { 
      $tmp = sprintf("%s too %s: %f in %s" . $newLine
                       , $opttemperatures         ? "temperature" : "humidity"
                       , $warnlevel < $critlevel  ? "high"        : "low"
                       , $opttemperatures         ? $VALUEARR[0]  : $VALUEARR[1]
                       , $ROOM );
      $nagmsg = $nagmsg . $tmp;
      if (
         ( ($warnlevel < $critlevel) && ($value >= $critlevel) )||
         ( ($warnlevel > $critlevel) && ($value <= $critlevel) )  )
        $retCode = NAGIOS_STATE_CRITICAL;
      }
    }
  if ( ! empty($nagmsg) )
    {
    michaelano\SmartHomePHP\NagiosMsgAndExit($retCode,$nagmsg);
    }
  else
    {
    michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_OK,$okmsg);
    }
  }  







if ( ($optmsgs) || ($optmsgsnew) )
  {
  $MSGS = michaelano\SmartHomePHP\GetMessages( &$sh, $CONFIGR, $optmsgsnew, $optdebug);
  $countnew=0;
  $msg = "";
  if ( ! empty($MSGS) )
    {
    asort($MSGS); // newest on top
    $i = 0;
    foreach($MSGS as $TIMESTAMP => $VALUEARR) 
      {
      $tmp = sprintf ( " %s %s (%s %s)" . $newLine
                   , $TIMESTAMP  , $VALUEARR[1] ,$VALUEARR[4], $VALUEARR[5]);
      $msg = $msg . $tmp;
      $i++;
      if ("$VALUEARR[0]" == "New") 
        $countnew++;
      }
    }

  if (count($MSGS) >= $warnlevel)
    {
    $nagmsg = sprintf("too many %smessages (%d) ", $optmsgsnew ? "new " : "",count($MSGS)) . $msg;
    if (count($MSGS) >= $critlevel)
      {
      michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_CRITICAL,$nagmsg);
      }
    else
      {
      michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_WARNING,$nagmsg);
      }
    }
  else
    {
    $nagmsg = sprintf("%d %s messages.", count($MSGS), $optmsgsnew ? "new" : "") ;
    michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_OK,$nagmsg);
    }
  }







// --- End
if ($optverbose) 
  {
  echo "--- End:" . date ("r") . $newLine;
  }

michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_OK, "OK");

?>
