<?php

/**
 * example skript for Class SmartHome,  see:   https://github.com/Bubelbub/SmartHome-PHP
 *
 * @author     michaelano user from http://www.rwe-smarthome-forum.de
 * @version    0.10
 *     0.10  adapted for new "SmartHome-PHP-master" Version from 2014-07-14
 */

/*
 TODO:
  - remove need to customize rrd_update commandby admin

*/


/* Usage: 

php <path-to-script>/example2.php -h



php <path-to-script>/example2.php -s



- example Temp/Humidity Logging:  enter this in crontab    (i.e. for CentOS 6) (you need to customize the shell skripts, an you have to create a rrd file first)
0,5,10,15,20,25,30,35,40,45,50,55 * * * * root php <path-to-script>/example2.php -V -t  -e /var/log/michaelano/temp_and_humidity.rrd -E /var/www/html/rwe/th1.html  2>&1 >> /var/log/michaelano/example2.log && <path-to-script>/rrdtool-examples/create_rrd_graphs.sh




*/
/*
Customization:

- customize config.ini File (or apply login info by the -H -u -p options)
- Path to $rrdFile and $htmlFile (or apply them by the -E and -e options)
- customize rrd_update command (search for "rrd_update")
- text in $exporttohtml section
*/
require_once 'michaelano/SmartHome-Utils.php';
/*
mit alter Version der Lib
require_once 'SmartHome-PHP-master/SmartHome.php';require_once 'SmartHome-PHP-master/SmartHome.php';
require_once 'SmartHome-PHP-master/SmartHome.php';
require_once 'SmartHome-PHP-master/Request/BaseRequest.php';
require_once 'SmartHome-PHP-master/Request/LoginRequest.php';
require_once 'SmartHome-PHP-master/Request/GetEntitiesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcInformationRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllLogicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetApplicationTokenRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcTypeRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllPhysicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetMessageListRequest.php';
*/

use Bubelbub\SmartHomePHP\SmartHome;
use Bubelbub\SmartHomePHP\Entity\LogicalDevice;

require_once 'SmartHome-PHP-master/SmartHome.php';
require_once 'SmartHome-PHP-master/Request/BaseRequest.php';
require_once 'SmartHome-PHP-master/Request/LoginRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllLogicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetMessageListRequest.php';
require_once 'SmartHome-PHP-master/Request/GetEntitiesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllPhysicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcInformationRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcTypeRequest.php';
require_once 'SmartHome-PHP-master/Request/GetUpdatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetApplicationTokenRequest.php';
require_once 'SmartHome-PHP-master/Entity/Entity.php';
require_once 'SmartHome-PHP-master/Entity/Location.php';
require_once 'SmartHome-PHP-master/Entity/LogicalDevice.php';
require_once 'SmartHome-PHP-master/Entity/Actuator.php';
require_once 'SmartHome-PHP-master/Entity/SwitchActuator.php';
require_once 'SmartHome-PHP-master/Entity/WindowDoorSensor.php';
require_once 'SmartHome-PHP-master/Entity/PushButtonSensor.php';
require_once 'SmartHome-PHP-master/Entity/ThermostatActuator.php';
require_once 'SmartHome-PHP-master/Entity/ValveActuator.php';
require_once 'SmartHome-PHP-master/Entity/RoomTemperatureActuator.php';
require_once 'SmartHome-PHP-master/Request/SetActuatorStatesRequest.php';
require_once 'SmartHome-PHP-master/Entity/TemperatureSensor.php';
require_once 'SmartHome-PHP-master/Entity/RoomTemperatureSensor.php';
require_once 'SmartHome-PHP-master/Entity/HumiditySensor.php';
require_once 'SmartHome-PHP-master/Entity/RoomHumiditySensor.php';
require_once 'SmartHome-PHP-master/Entity/MotionDetectionSensor.php';
require_once 'SmartHome-PHP-master/Entity/LuminanceSensor.php';
require_once 'SmartHome-PHP-master/Entity/AlarmActuator.php';
require_once 'SmartHome-PHP-master/Entity/SmokeDetectorSensor.php';
require_once 'SmartHome-PHP-master/Entity/GenericActuator.php';
require_once 'SmartHome-PHP-master/Entity/GenericSensor.php';





define('RRD_INTERVAL', 	 300);







/**
 *  print help
 *
 * @param string $prgname
 * @param string $newLine
 */
function print_help_message ($prgname,$newLine)
{
  if  (php_sapi_name() == 'cli')
    {
    echo   "Usage: php $prgname [options]" . $newLine;
    }
  else
    {
    echo   "Options:" . $newLine;
    }
  echo   "       " . $newLine;
  echo   "  -h, --help             show this help" . $newLine;
  echo   "  -s, --alldevstates     show AllLogicalDeviceStates" . $newLine;
  echo   "  -t, --temperature      show Temperature/Humidity (check temperature in case of nagios Plugin)" . $newLine;
  echo   "  -T, --humidity         show Temperature/Humidity (check humidity in case of nagios Plugin)" . $newLine;
  echo   "  -r, --rooms            show Rooms" . $newLine;
  echo   "  -b, --bds              show BDs" . $newLine;
  echo   "  -l, --lds              show Logival Devices" . $newLine;
  echo   "  -m, --messages         show Messages" . $newLine;
  echo   "  -M                     show (only) new Messages" . $newLine;
  echo   "  -a, --all              show Rooms, BDs, Logocal Devices, AllLogicalDeviceStates, Messages" . $newLine;
  echo   "  -e <expfile>           export to rrdfile  (only Values of Rst) (use <expfile>==\".\" for Defaultfilename)" . $newLine;
  echo   "  -E <expfile>           export to htmlFile (only Values of Rst) (use <expfile>==\".\" for Defaultfilename)" . $newLine;
  echo   "  -H <hostname>          hostname of shc" . $newLine;
  echo   "  -u <userid>            userid for login to shc" . $newLine;
  echo   "  -p <passwd>            passwd for login to shc" . $newLine;
  echo   "  -w <warnlevel>         acts as nagios plugin, set warnlevel (use this with -t,-T,-m or -M)" . $newLine;
  echo   "  -c <critlevel>         acts as nagios plugin, set critlevel (use this with -t,-T,-m or -M)" . $newLine;
  echo   "  -v, --verbose          verbose output" . $newLine;
  echo   "  -V, --verboselight     verbose start and end of program" . $newLine;
  echo   "  -d, --debug            debug output" . $newLine;
}







// --- inits
$newLine             = php_sapi_name() == 'cli' ? "\n" : '<br />';
$configcachefile     = 'Configuration.cache';
$configIniFile       = __DIR__ . '/config.ini';
$rrdFile             = "/var/log/smarthome/temp_and_humidity.rrd";                 # enter your path here
$htmlFile            = "/var/www/html/smarthome/th1.html";                         # enter your path here

$argv0               = $argv[0];
$hostname            = "";
$userid              = "";
$passwd              = "";
$optalldevstates     = false;
$opttemperatures     = false;
$opthumidity         = false;
$optrooms            = false;
$optbds              = false;
$optlds              = false;
$optmsgs             = false;
$optmsgsnew          = false;
$optverbose          = false;
$optverboselight     = false;
$optdebug            = false;
$exporttorrd         = false;
$exporttohtml        = false;
$nagiosplugin        = false;

$getlogicaldevstates = false;














// --- command line arguments
$opts = michaelano\SmartHomePHP\getoptreq('hstTrblmMae:E:H:u:p:w:c:vVd', array('help', 'alldevstates', 'temperature', 'humidity', 'rooms', 'bds', 'lds', 'messages',null , 'all', null, null, null, null, null, null, null, 'verbose', 'verboselight', 'debug'));
foreach ($opts as $opt => $param) 
  {
  switch ($opt) 
    {
    case 's':
      $optalldevstates = true;
      $getlogicaldevstates = true;
      break;

    case 't':
      $opttemperatures = true;
      $getlogicaldevstates = true;
      break;

    case 'T':
      $opthumidity = true;
      $getlogicaldevstates = true;
      break;

    case 'r':
      $optrooms = true;
      break;

    case 'b':
      $optbds = true;
      break;

    case 'l':
      $optlds = true;
      break;  

    case 'm':
      $optmsgs = true;
      break;

    case 'M':
      $optmsgsnew = true;
      break;

    case 'a':
      $optalldevstates = true;
      $optrooms = true;
      $optbds = true;
      $optlds = true;
      $optmsgs = true;
      $getlogicaldevstates = true;
      break;

    case 'e':
      $exporttorrd = true;
      $getlogicaldevstates = true;
      if ( $param != ".")
        $rrdFile = $param;
      break;

    case 'E':
      $exporttohtml = true;
      $getlogicaldevstates = true;
      if ( $param != ".")
        $htmlFile = $param;
      break;

    case 'H':
      $hostname = $param;
      break;

    case 'u':
      $userid = $param;
      break;

    case 'p':
      $passwd = $param;
      break;

    case 'w':
      $warnlevel    = floatval($param);
      $nagiosplugin = true;
      break;

    case 'c':
      $critlevel    = floatval($param);
      $nagiosplugin = true;
      break;

    case 'v':
      $optverbose = true;
      break;

    case 'V':
      $optverboselight = true;
      break;

    case 'd':
      $optdebug = true;
      break;

    case 'h':
      print_help_message($argv0,$newLine);
      exit(1);
    }
  }
if (count($opts) <= 0)
  { // default action if no params are given
  $opttemperatures = true;
  $getlogicaldevstates = true;
  }




// ---
if ($nagiosplugin)
  {
  if ( ! isset($warnlevel) )
    michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage of plugin: warnlevel missing");
  if ( ! isset($critlevel) )
    michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage of plugin: critlevel missing");
  }






// --- Start 
if ( ($optverbose) || ($optverboselight) )
  {
  printf ("--- %s --- : %s" . $newLine , date ("r") , "Start" ) ;
  }







// --- construct SmartHome object
//$sh = new \Bubelbub\SmartHomePHP\SmartHome('Hostname or IP address', 'Username', 'Password');
//$sh = new \Bubelbub\SmartHomePHP\SmartHome($hostname,$userid,$passwd);
$sh = michaelano\SmartHomePHP\SmartHomeLogin($configIniFile,$hostname,$userid,$passwd);
if ($optdebug) 
  {
  print_r($sh->getShcInformation());
  }

if ($optverbose)
  {
  printf ("ConfigVrs: %s  (ShcVersion: %s, SessionId: %s)" . $newLine, $sh->getConfigVersion() ,$sh->getVersion() ,$sh->getSessionId()   ) ;
  printf ("--- %s --- : %s" . $newLine , date ("r") , "after Login" ) ;
  }











$CONFIGR = michaelano\SmartHomePHP\GetConfigR($sh,$configcachefile, $optdebug);
$ROOMS   = $CONFIGR['Rooms'];
$BDS     = $CONFIGR['BDs']  ;
$LDS     = $CONFIGR['LDs']  ;



if ($optverbose) 
  {
  printf ("--- %s --- : %s" . $newLine , date ("r") , "after Config read" ) ;
  }







// --- show Room infos  
if ($optrooms) 
  { 
  printf ( $newLine . $newLine . $newLine);
  printf ( "--LC    ID                                     Room                Pos." . $newLine); 
  printf ( "----    --                                     ----                ----" . $newLine); 
  $i = 0;
  foreach($ROOMS as $ID => $VALUEARR) 
    {
    printf ( "-- %-02d : %s   %-20s %-20s " . $newLine
               , $i,  $ID, $VALUEARR[0], $VALUEARR[1] );
    $i++;
    }
  }

// --- show BD infos  
if ($optbds) 
  { 
  printf ( $newLine . $newLine . $newLine);
  printf ( "--BD    ID                                     SerialNo.            Type     Room         ???" . $newLine); 
  printf ( "----    --                                     ---------            ----     -----------  ---" . $newLine); 
  $i = 0;
  foreach($BDS as $ID => $VALUEARR) 
    {
    printf ( "-- %-02d : %s   %-20s %-8s %-12s %s" . $newLine
               , $i,  $ID, $VALUEARR[1], $VALUEARR[0], $VALUEARR[3], $VALUEARR[2] );
    $i++;
    }
  }

// --- show Logical Devices
if ($optlds) 
  { 
  printf ( $newLine . $newLine . $newLine);
  printf ( "--LD    ID                                     LCID                                   Room           BDType   BDId.                                  Name" . $newLine);
  printf ( "----    --                                     ----                                   ----           ------   -----                                  ----" . $newLine);
  $i = 0;
  foreach($LDS as $ID => $VALUEARR) 
    {
    printf ( "-- %-02d : %-36s   %-36s   %-12s   %-8s %-36s   %s" . $newLine
                   , $i,   $ID,    $VALUEARR[1], $VALUEARR[4], $VALUEARR[3] , $VALUEARR[2] , $VALUEARR[0]);
    $i++;
    }
  }







// --- determine LogicalDeviceStates
if ( $getlogicaldevstates)
  {
  $RSTDATA = michaelano\SmartHomePHP\GetLogicalDeviceStates( $sh, $CONFIGR, true, $optdebug);
  }










if ( $getlogicaldevstates)
  {
  if ($exporttorrd)
    {
    if (empty($RSTDATA))
      {
      NagiosMsgAndExit(NAGIOS_STATE_CRITICAL,"no sensor data for Rst found");
      }
    $timestamp = intval(date("U")/ RRD_INTERVAL )* RRD_INTERVAL ;

    //ADJUST rrd_update Command to your needs
    $ret = rrd_update($rrdFile, array("$timestamp:{$RSTDATA['RAUM01'][0]}:{$RSTDATA['RAUM01'][1]}:{$RSTDATA['RAUM01'][2]}:{$RSTDATA['RAUM02'][0]}:{$RSTDATA['RAUM02'][1]}:{$RSTDATA['RAUM02'][2]}:{$RSTDATA['RAUM03'][0]}:{$RSTDATA['RAUM03'][1]}:{$RSTDATA['RAUM03'][2]}:{$RSTDATA['RAUM04'][0]}:{$RSTDATA['RAUM04'][1]}:{$RSTDATA['RAUM04'][2]}:{$RSTDATA['RAUM05'][0]}:{$RSTDATA['RAUM05'][1]}:{$RSTDATA['RAUM05'][2]}:{$RSTDATA['RAUM06'][0]}:{$RSTDATA['RAUM06'][1]}:{$RSTDATA['RAUM06'][2]}" ));
    if( $ret == 0 )
      {
      $err = rrd_error();
      echo "ERROR occurred: $err\n";
      exit (1);
      }
    }


  if ($exporttohtml)
    {
    if (empty($RSTDATA))
      {
      NagiosMsgAndExit(NAGIOS_STATE_CRITICAL,"no sensor data for Rst found");
      }
    ob_start(); 
    echo '<HTML><HEAD><TITLE>th1.html:  Uebersicht Temperaturen (und Luftfeuchte), nur Text</TITLE></HEAD><BODY>';
    printf("Stand: %s<p>",date(r));
    echo '<table border=\"1\">';
    echo '<tr><td>Room</td><td>Temp</td><td>Humi</td><td>Rst</td><td>Mode</td><td>WRAc</td></tr>';
    foreach($RSTDATA as $ROOM => $VALUEARR) 
      {
      printf("<tr><td>%-3s</td><td>%-5s</td><td>%-5s</td><td>%-5s</td><td>%-4s</td><td>%s</td></tr>",$ROOM, $VALUEARR[0], $VALUEARR[1], $VALUEARR[2] , $VALUEARR[3] , $VALUEARR[4]);
      }
    echo '</table>';
    echo '</BODY></HTML>';
    $data = ob_get_contents(); 
    $fp = fopen("$htmlFile","w"); 
    fwrite($fp,$data); 
    fclose($fp); 
    ob_clean(); 
    }





  if ($nagiosplugin)
    {
    $nagmsg  = "";
    $retCode = NAGIOS_STATE_WARNING;
    foreach($RSTDATA as $ROOM => $VALUEARR) 
      {
      $value = floatval($opttemperatures ? $VALUEARR[0] : $VALUEARR[1]);

      if (
         ( ($warnlevel < $critlevel) && ($value >= $warnlevel) )||
         ( ($warnlevel > $critlevel) && ($value <= $warnlevel) )  )
        { 
        $tmp = sprintf("%s too %s: %f in %s" . $newLine
                       , $opttemperatures         ? "temperature" : "humidity"
                       , $warnlevel < $critlevel  ? "high"        : "low"
                       , $opttemperatures         ? $VALUEARR[0]  : $VALUEARR[1]
                       , $ROOM );
        $nagmsg = $nagmsg . $tmp;
        if (
           ( ($warnlevel < $critlevel) && ($value >= $critlevel) )||
           ( ($warnlevel > $critlevel) && ($value <= $critlevel) )  )
          $retCode = NAGIOS_STATE_CRITICAL;
        }
      }
    if ( ! empty($nagmsg) )
      {
      michaelano\SmartHomePHP\NagiosMsgAndExit($retCode,$nagmsg);
      }
    }
  else
    {
    if ( ($opttemperatures) || ($opthumidity) || ($optalldevstates) )
      {
      if ( ! empty($RSTDATA))
        {
        foreach($RSTDATA as $ROOM => $VALUEARR) 
          {
          printf("%-3s     %-5s     %-5s     %-5s  %-4s %s" . $newLine,$ROOM, $VALUEARR[0], $VALUEARR[1], $VALUEARR[2] , $VALUEARR[3] , $VALUEARR[4]);
          }
        }
      }

    if ($optalldevstates)
      {
      $STATES = michaelano\SmartHomePHP\GetLogicalDeviceStates( $sh, $CONFIGR, false);
      if (empty($STATES))
        {
        NagiosMsgAndExit(NAGIOS_STATE_CRITICAL,"no sensor data found");
        }
      foreach($STATES as $LID => $VALUEARR) 
        {
        printf("%s   %-12s   %-5s   %s    %s   %s" . $newLine,$LID, $VALUEARR[0], $VALUEARR[1], $VALUEARR[2] , $VALUEARR[3] , $VALUEARR[4]);
        }
      }
    }
  }  







if ( ($optmsgs) || ($optmsgsnew) )
  {
  $MSGS = michaelano\SmartHomePHP\GetMessages( &$sh, $CONFIGR, $optmsgsnew, $optdebug);
  $countnew=0;
  if ( ! empty($MSGS) )
    {
    if ( $nagiosplugin)  
      {
      asort($MSGS); // newest on top
      }
    else
      {
      printf ( $newLine . $newLine . $newLine);
      printf ( "--Msg   State   Timestamp                   Type" . $newLine); 
      printf ( "-----   -----   ---------                   ----" . $newLine); 
      }
    $i = 0;
    $msg = "";
    foreach($MSGS as $TIMESTAMP => $VALUEARR) 
      {
      if ( $nagiosplugin)  
        {
        $tmp = sprintf ( " %s %s (%s %s)" . $newLine
                     , $TIMESTAMP  , $VALUEARR[1] ,$VALUEARR[4], $VALUEARR[5]);
        $msg = $msg . $tmp;
        }
      else
        {
        printf ( "-- %-02d : %-5s   %-25s   %-30s   %s %s    (%s %s)" . $newLine
                     , $i,  $VALUEARR[0],  $TIMESTAMP   , $VALUEARR[1] ,$VALUEARR[2], $VALUEARR[3],$VALUEARR[4], $VALUEARR[5]);
        }
      $i++;
      if ("$VALUEARR[0]" == "New") 
        $countnew++;
      }
    if ( ($optmsgsnew) && ( ! $nagiosplugin)  )
      {
      printf ( $newLine . "You have %d new Message(s)" . $newLine . $newLine, $countnew );
      }
    }

  if ( ( isset($warnlevel) ) && (count($MSGS) >= $warnlevel) )
    {
    $nagmsg = sprintf("too many %s messages (%d) ", $optmsgsnew ? "new" : "",count($MSGS)) . $msg;
    if ( ( isset($critlevel) ) && (count($MSGS) >= $critlevel) )
      {
      michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_CRITICAL,$nagmsg);
      }
    else
      {
      michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_WARNING,$nagmsg);
      }
    }
  }







// --- End
if ( ($optverbose) || ($optverboselight) )
  {
  echo "--- End:" . date ("r") . $newLine;
  }
?>
