#
# erzeuge graphen der aus der RWE-Smarthome Zentrale ausgelsenen Daten
#
#  Anzeigebereiche: Temp von 10 - 25 Grad Celsius         --> 15 Skalenteile
#                   Humi     30 - 75 % rel. Luftfeuchte   --> 45 Skalenteile
#                      --> resultiert: Luftfeuchte werte umrechnen zu Temp Werte:  (LUFTF/3)
#
#   Webpage aktivieren: siehe /etc/httpd/conf.d/rwe.conf  (CentOS)
#
#
#


     PRGNAME=$0
#      TYPES=(Temp Humi Actu)
      ROOMS=(RAUM01 RAUM02 RAUM03 RAUM04 RAUM05 RAUM06)
   COLVALUE=(00007F 0000FF 007F00 00FF00 7F0000 FF0000)

     DBPATH=~/DBs
    RRDFILE=$DBPATH/temp_and_humidity.rrd

    WWWPATH=/var/www/rwe
    test -e /etc/redhat-release && WWWPATH=/var/www/html/rwe
   WWWFILE1=$WWWPATH/th0.html
   WWWFILE2=$WWWPATH/th2.html
   WWWFILE3=$WWWPATH/th3.html
   WWWFILE4=$WWWPATH/th4.html
    IMGPATH=$WWWPATH/img


      START="--start -1d"
        END=
    IMGSIZE="-w 864 -h 600"
   LIMITS01="-u 25 -l 10 -r"
  RIGHTAXIS="--right-axis 3:0"  

#   SPECIALS="-L 4"  
#   SPECIALS="-v Vertical-label"  
   SPECIALS="--x-grid MINUTE:15:HOUR:1:HOUR:1:0:%k"  
    IMGINFO='<IMG SRC="img/%s" WIDTH="%lu" HEIGHT="%lu"'
#  WATERMARK=
  WATERMARK="generated by $USER with $PRGNAME at `date`"



printf "<HTML><HEAD><TITLE>th1.html:  Uebersicht Temperaturen (und Luftfeuchte), nur Text</TITLE></HEAD><BODY>\n"                > $WWWFILE1
printf "<HTML><HEAD><TITLE>th2.html:  Uebersicht Temperaturen (und Luftfeuchte), incl. Vorschaubilder</TITLE></HEAD><BODY>\n"    > $WWWFILE2
printf "<HTML><HEAD><TITLE>th3.html:  Uebersicht Temperaturen (und Luftfeuchte), volle Grafiken</TITLE></HEAD><BODY>\n"          > $WWWFILE3


printf "Stand: `date +%c`<p/>\n"          >> $WWWFILE1
printf "Stand: `date +%c`<p/>\n"          >> $WWWFILE2
printf "Stand: `date +%c`<p/>\n"          >> $WWWFILE3


# --- WWWFILE1
  printf "<table border=\"1\">" >> $WWWFILE1
  TIME=$(date +%s)
  RRDRES=300
#  printf "%s\n" `  rrdtool fetch $RRDFILE AVERAGE -r $RRDRES -e $(($TIME/$RRDRES*$RRDRES)) -s e-5min -r 300 | tail -2|head -n 1| sed 's/-nan//g'| awk -F : '{print $2}' `
  printf "<tr><td>%-02.1f</td><td>%-02.1f</td><td>%-02.1f</td></tr>" `  rrdtool fetch $RRDFILE AVERAGE -r $RRDRES -e $(($TIME/$RRDRES*$RRDRES)) -s e-5min -r 300 | tail -2|head -n 1| sed 's/-nan//g'| awk -F : '{print $2}'`  >> $WWWFILE1
  printf "</table>" >> $WWWFILE1





# --- Main Loop
typeset -i i 
let i=0
  TEMPDEFGRAPH=
  HUMIDEFGRAPH=
for ROOM in ${ROOMS[@]}
do
#  for TYPE in ${TYPES[@]}
#  do
#    SOURCE=${TYPE}_${ROOM}
#  done
     TYPE=Temp
    DEF01=DEF:$TYPE${ROOM}=$RRDFILE:${TYPE}_${ROOM}:AVERAGE
  GRAPH01=LINE1:$TYPE${ROOM}#ff0000:${TYPE}_${ROOM}

  TEMPDEFGRAPH="$TEMPDEFGRAPH $DEF01 LINE1:$TYPE${ROOM}#${COLVALUE[$i]}:${TYPE}_${ROOM}"

     TYPE=Actu
    DEF02=DEF:$TYPE${ROOM}=$RRDFILE:${TYPE}_${ROOM}:AVERAGE
  GRAPH02=LINE1:$TYPE${ROOM}#00ff00:${TYPE}_${ROOM}

     TYPE=Humi
    DEF03=DEF:$TYPE${ROOM}=$RRDFILE:${TYPE}_${ROOM}:AVERAGE
   CDEF03="CDEF:my$TYPE${ROOM}=$TYPE${ROOM},3,/"
  GRAPH03=LINE1:my$TYPE${ROOM}#0000ff:${TYPE}_${ROOM}

  HUMIDEFGRAPH="$HUMIDEFGRAPH $DEF03 LINE1:$TYPE${ROOM}#${COLVALUE[$i]}:${TYPE}_${ROOM}"


# --- WWWFILE1
  printf  "<p/>$ROOM:\n"        >> $WWWFILE1


# --- WWWFILE3
  printf  "<h1>$ROOM</h1>\n"        >> $WWWFILE3
  rrdtool graph $START $END -t $ROOM $LIMITS01 $RIGHTAXIS -W "$WATERMARK" --imginfo "$IMGINFO" $SPECIALS $IMGSIZE $IMGPATH/$ROOM.png  \
                                                                           $DEF01 $DEF02 $DEF03 $CDEF03 $GRAPH01 $GRAPH02 $GRAPH03    | tee -a $WWWFILE3
  printf  "ALT=\"$ROOM Temperaturverlauf\"\>\n"        >> $WWWFILE3


# --- WWWFILE2
  printf  "<p/>$ROOM:\n<a href=\"img/$ROOM.png\">"        >> $WWWFILE2
  rrdtool graph $START $END -t $ROOM $LIMITS01 $RIGHTAXIS -W "$WATERMARK" --imginfo "$IMGINFO" $SPECIALS -w 100 -h 60 --only-graph $IMGPATH/thumb_$ROOM.png  \
                                                                           $DEF01 $DEF02 $DEF03 $CDEF03 $GRAPH01 $GRAPH02  $GRAPH03                           | tee -a $WWWFILE2
  printf  "ALT=\"$ROOM Temperaturverlauf Vorschau\"\></a>\n"        >> $WWWFILE2

  let i++
done

# --- Temperatur Übersicht ---

  RIGHTAXIS=
# --- WWWFILE3
printf  "<h1>Temperatur Übersicht</h1>\n"        >> $WWWFILE3
rrdtool graph $START $END -t "Luftfeuchte Übersicht" $LIMITS01 $RIGHTAXIS -W "$WATERMARK" --imginfo "$IMGINFO" $SPECIALS $IMGSIZE $IMGPATH/Temp-day.png  \
                                                                           $TEMPDEFGRAPH    | tee -a $WWWFILE3
printf  "ALT=\"Temperatur Übersicht\"\>\n"        >> $WWWFILE3


# --- Luftfeuchte Übersicht ---
   LIMITS01="-u 75 -l 30 -r"
  RIGHTAXIS=

# --- WWWFILE3
printf  "<h1>Luftfeuchte Übersicht</h1>\n"        >> $WWWFILE3
rrdtool graph $START $END -t "Luftfeuchte Übersicht" $LIMITS01 $RIGHTAXIS -W "$WATERMARK" --imginfo "$IMGINFO" $SPECIALS $IMGSIZE $IMGPATH/Humi-day.png  \
                                                                           $HUMIDEFGRAPH    | tee -a $WWWFILE3
printf  "ALT=\"Luftfeuchte Übersicht\"\>\n"        >> $WWWFILE3


printf "</BODY></HTML>\n"  >> $WWWFILE1
printf "</BODY></HTML>\n"  >> $WWWFILE2
printf "</BODY></HTML>\n"  >> $WWWFILE3









# --- Weekly Graphs ---
      START="--start -1w"
    IMGSIZE="-w 1008 -h 600"
   SPECIALS="--x-grid HOUR:3:DAY:1:HOUR:12:0:%a%k"  


printf "<HTML><HEAD><TITLE>th4.html: Wochen-Uebersicht Temperaturen (und Luftfeuchte), volle Grafiken</TITLE></HEAD><BODY>\n"          > $WWWFILE4
printf "Stand: `date +%c`<p/>\n"          >> $WWWFILE4
for ROOM in ${ROOMS[@]}
do
     TYPE=Temp
    DEF01=DEF:$TYPE=$RRDFILE:${TYPE}_${ROOM}:AVERAGE
  GRAPH01=LINE1:$TYPE#ff0000:${TYPE}_${ROOM}

     TYPE=Actu
    DEF02=DEF:$TYPE=$RRDFILE:${TYPE}_${ROOM}:AVERAGE
  GRAPH02=LINE1:$TYPE#00ff00:${TYPE}_${ROOM}

     TYPE=Humi
    DEF03=DEF:$TYPE=$RRDFILE:${TYPE}_${ROOM}:AVERAGE
   CDEF03="CDEF:my$TYPE=$TYPE,3,/"
  GRAPH03=LINE1:my$TYPE#0000ff:${TYPE}_${ROOM}

# --- WWWFILE4
  printf  "<h1>$ROOM</h1>\n"        >> $WWWFILE4
  rrdtool graph $START $END -t $ROOM $LIMITS01 $RIGHTAXIS -W "$WATERMARK" --imginfo "$IMGINFO" $SPECIALS $IMGSIZE $IMGPATH/$ROOM-weekly.png  \
                                                                           $DEF01 $DEF02 $DEF03 $CDEF03 $GRAPH01 $GRAPH02 $GRAPH03    | tee -a $WWWFILE4
  printf  "ALT=\"$ROOM Temperaturverlauf\"\>\n"        >> $WWWFILE4


done
printf "</BODY></HTML>\n"  >> $WWWFILE4

#
