<?php

/**
 *
 *
 * example:    
 *
 *   php './set_rst_actuator.php' -r <roomname> -t 8.0 -m manu
 *
 *
 *
 *
 *
 * testt skript for use of    addRoomTemperatureActuatorState($logicalDeviceId, $pointTemperature, $mode) 
 *                    needs SmartHome-PHP, see:  https://github.com/Bubelbub/SmartHome-PHP
 *
 * @author     michaelano user from http://www.rwe-smarthome-forum.de
 * @version    0.02
 *     0.02  adapted for new "SmartHome-PHP-master" Version from 2014-07-14
 */






/*
Customization:
- customize config.ini File (or apply login info by the -H -u -p options)
*/


require_once 'michaelano/SmartHome-Utils.php';
/*
mit alter Version der Lib
require_once 'SmartHome-PHP-master/SmartHome.php';require_once 'SmartHome-PHP-master/SmartHome.php';

require_once 'SmartHome-PHP-master/Request/BaseRequest.php';
require_once 'SmartHome-PHP-master/Request/LoginRequest.php';
require_once 'SmartHome-PHP-master/Request/GetEntitiesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcInformationRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllLogicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetApplicationTokenRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcTypeRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllPhysicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetMessageListRequest.php';
require_once 'SmartHome-PHP-master/Request/SetActuatorStatesRequest.php';
*/


use Bubelbub\SmartHomePHP\SmartHome;
use Bubelbub\SmartHomePHP\Entity\LogicalDevice;

require_once 'SmartHome-PHP-master/SmartHome.php';
require_once 'SmartHome-PHP-master/Request/BaseRequest.php';
require_once 'SmartHome-PHP-master/Request/LoginRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllLogicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetMessageListRequest.php';
require_once 'SmartHome-PHP-master/Request/GetEntitiesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetAllPhysicalDeviceStatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcInformationRequest.php';
require_once 'SmartHome-PHP-master/Request/GetShcTypeRequest.php';
require_once 'SmartHome-PHP-master/Request/GetUpdatesRequest.php';
require_once 'SmartHome-PHP-master/Request/GetApplicationTokenRequest.php';
require_once 'SmartHome-PHP-master/Entity/Entity.php';
require_once 'SmartHome-PHP-master/Entity/Location.php';
require_once 'SmartHome-PHP-master/Entity/LogicalDevice.php';
require_once 'SmartHome-PHP-master/Entity/Actuator.php';
require_once 'SmartHome-PHP-master/Entity/SwitchActuator.php';
require_once 'SmartHome-PHP-master/Entity/WindowDoorSensor.php';
require_once 'SmartHome-PHP-master/Entity/PushButtonSensor.php';
require_once 'SmartHome-PHP-master/Entity/ThermostatActuator.php';
require_once 'SmartHome-PHP-master/Entity/ValveActuator.php';
require_once 'SmartHome-PHP-master/Entity/RoomTemperatureActuator.php';
require_once 'SmartHome-PHP-master/Request/SetActuatorStatesRequest.php';
require_once 'SmartHome-PHP-master/Entity/TemperatureSensor.php';
require_once 'SmartHome-PHP-master/Entity/RoomTemperatureSensor.php';
require_once 'SmartHome-PHP-master/Entity/HumiditySensor.php';
require_once 'SmartHome-PHP-master/Entity/RoomHumiditySensor.php';
require_once 'SmartHome-PHP-master/Entity/MotionDetectionSensor.php';
require_once 'SmartHome-PHP-master/Entity/LuminanceSensor.php';
require_once 'SmartHome-PHP-master/Entity/AlarmActuator.php';
require_once 'SmartHome-PHP-master/Entity/SmokeDetectorSensor.php';
require_once 'SmartHome-PHP-master/Entity/GenericActuator.php';
require_once 'SmartHome-PHP-master/Entity/GenericSensor.php';








/**
 *  print help
 *
 * @param string $prgname
 * @param string $newLine
 */
function print_help_message ($prgname,$newLine)
{
  if  (php_sapi_name() == 'cli')
    {
    echo   "Usage: php $prgname [options]" . $newLine;
    }
  else
    {
    echo   "Options:" . $newLine;
    }
  echo   "       " . $newLine;
  echo   "  -h, --help             show this help" . $newLine;
  echo   "  -r <room>              set for<room>" . $newLine;
  echo   "  -t <temperature>       set actuator to <temperature> (only steps of 0.5 allowed)" . $newLine;
  echo   "  -m <mode>              set mode Auto|Manu" . $newLine;
  echo   "  -H <hostname>          hostname of shc" . $newLine;
  echo   "  -u <userid>            userid for login to shc" . $newLine;
  echo   "  -p <passwd>            passwd for login to shc" . $newLine;
//  echo   "  -x <xmode>             set diferent mode for testing (if any works ...)" . $newLine;
  echo   "  -v, --verbose          verbose output" . $newLine;
  echo   "  -d, --debug            debug output" . $newLine;
}







// --- inits
$newLine             = php_sapi_name() == 'cli' ? "\n" : '<br />';
$configcachefile     = 'Configuration.cache';
$configIniFile       = __DIR__ . '/config.ini';

$argv0               = $argv[0];
$hostname            = "";
$userid              = "";
$passwd              = "";
$optroom             = null;
$opttemperature      = null;
$optmode             = null;
$optverbose          = false;
$optdebug            = false;
//$xmode               = 1;













//$opts = michaelano\SmartHomePHP\getoptreq('x:hr:t:m:H:u:p:vd', array('help',null ,null,null,null, null, null, 'verbose','debug'));
$opts = michaelano\SmartHomePHP\getoptreq('hr:t:m:H:u:p:vd', array('help',null ,null,null,null, null, null, 'verbose','debug'));
// --- command line arguments
foreach ($opts as $opt => $param) 
  {
  switch ($opt) 
    {
    /*case 'x':
      $xmode = intval($param);
      break;*/

    case 'r':
      $optroom = $param;
      break;

    case 't':
      $opttemperature = $param;
      break;

    case 'm':
      $optmode = $param;
      break;

    case 'H':
      $hostname = $param;
      break;

    case 'u':
      $userid = $param;
      break;

    case 'p':
      $passwd = $param;
      break;

    case 'v':
      $optverbose = true;
      break;

    case 'd':
      $optdebug = true;
      break;

    case 'h':
      print_help_message($argv0,$newLine);
      exit(1);
    }
  }


if ( ! isset($optroom) )
  michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage: parameter for room is missing");

if ( ! isset($opttemperature) )
  michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage: parameter for temerature is missing");

if ( ! isset($optmode) )
  michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_UNKNOWN, "wrong usage: parameter for mode is missing");







// --- Start 
if ($optverbose)
  {
  printf ("--- %s --- : %s" . $newLine , date ("r") , "Start" ) ;
  }







// --- construct SmartHome object
//$sh = new \Bubelbub\SmartHomePHP\SmartHome('Hostname or IP address', 'Username', 'Password');
//$sh = new \Bubelbub\SmartHomePHP\SmartHome($hostname,$userid,$passwd);
$sh = michaelano\SmartHomePHP\SmartHomeLogin($configIniFile,$hostname,$userid,$passwd);
if ($optdebug) 
  {
  print_r($sh->getShcInformation());
  }

if ($optverbose)
  {
  printf ("ConfigVrs: %s  (ShcVersion: %s, SessionId: %s)" . $newLine, $sh->getConfigVersion() ,$sh->getVersion() ,$sh->getSessionId()   ) ;
  printf ("--- %s --- : %s" . $newLine , date ("r") , "after Login" ) ;
  }











$CONFIGR = michaelano\SmartHomePHP\GetConfigR($sh,$configcachefile, $optdebug);
//$ROOMS   = $CONFIGR['Rooms'];
//$BDS     = $CONFIGR['BDs']  ;
$LDS     = $CONFIGR['LDs']  ;
if ($optverbose) 
  {
  printf ("--- %s --- : %s" . $newLine , date ("r") , "after Config read" ) ;
  }


//printf ( "-- xmode:  %d" . $newLine,$xmode);

$i = 0;
foreach($LDS as $ID => $VALUEARR) 
  {
  $i++;
  if ( $VALUEARR[4] != "$optroom" )
   continue;

    /* removed, assuming only one item "Heizung" per room possible  
    if ( $VALUEARR[3] != 'Rst' )
      continue;*/
    if ( $VALUEARR[0] != "Heizung" )
     continue;  

  printf ( "-- %-02d : %-36s   %s    %s    (%s/%s)" . $newLine, $i,   $ID, $opttemperature, $optmode,$VALUEARR[3],$VALUEARR[0]);
  $request = new \Bubelbub\SmartHomePHP\Request\SetActuatorStatesRequest($sh);
  $request->addRoomTemperatureActuatorState($ID, $opttemperature, $optmode) ;
  $request->send();

  //$request->addRoomTemperatureActuatorState($ID, '15.0', 'Manu') ;

/*	$setActuatorStatesRequest = new \Bubelbub\SmartHomePHP\Request\SetActuatorStatesRequest($sh);
	$setActuatorStatesRequest->addRoomTemperatureActuatorState('f0d440ca-7529-4c34-bb18-d7c003eae6db', 13, 'auto');
	$setActuatorStatesRequest->send();
*/
  }







// --- End
if ($optverbose) 
  {
  echo "--- End:" . date ("r") . $newLine;
  }

michaelano\SmartHomePHP\NagiosMsgAndExit(NAGIOS_STATE_OK, "OK");

?>
